/*
  2 leaks
  1) when choosing region
  2) when doing strdup in indexing

 */
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <ctime>
#include <csignal>
#include <vector>
#include <stdint.h>

#include "utility.h"
#include "bams.h"
#include "mUpPile.h"
#include "interface.h"
#include "parseArgs_bambi.h"
#include "indexer.h"



void (*func)(void *) = NULL;

void printChunky2(const chunky* chk,FILE *fp,char *refStr) {
  //  fprintf(stderr,"[%s] nsites=%d region=(%d,%d) itrReg=(%d,%d)\n",__FUNCTION__,chk->nSites,chk->refPos[0],chk->refPos[chk->nSites-1],chk->regStart,chk->regStop);
  if(chk->refPos[0]>chk->regStop){
    fprintf(stderr,"\t->Problems with stuff\n");
    exit(0);
  }
  
  for(int s=0;s<chk->nSites;s++) {
    if(chk->refPos[s]<chk->regStart || chk->refPos[s]>chk->regStop-1 ){
      for(int i=0;i<chk->nSamples;i++)
	dalloc_node(chk->nd[s][i]);
      delete [] chk->nd[s];
      continue;
    }
    fprintf(fp,"%s\t%d",refStr,chk->refPos[s]+1);     
    
    for(int i=0;i<chk->nSamples;i++) {

      //      fprintf(stderr,"seqlen[%d,%d]=%lu\t",s,i,chk->nd[s][i].seq->l);
      if(chk->nd[s][i].seq.l!=0){
	fprintf(fp,"\t%d\t",chk->nd[s][i].depth);
	for(size_t l=0;l<chk->nd[s][i].seq.l;l++)
	  fprintf(fp,"%c",chk->nd[s][i].seq.s[l]);
      	fprintf(fp,"\t");
	
	for(size_t l=0;l<chk->nd[s][i].qs.l;l++)
	  fprintf(fp,"%c",chk->nd[s][i].qs.s[l]);
	//	fprintf(fp,"\t");

      }else
	fprintf(fp,"\t0\t*\t*");
      dalloc_node(chk->nd[s][i]);
    }
    //    fprintf(stderr,"\n");
    fprintf(fp,"\n");
    delete [] chk->nd[s];
  }
  delete [] chk->nd;
  delete [] chk->refPos;
  delete chk;
} 


chunk *fucker(chunky *chk){
  //  fprintf(stderr,"Baseline\n");
  if(func==NULL){
    printChunky2(chk,stdout,chk->refName);
    return NULL;
  }else{
    chunk *tmp = fetch(chk,chk->refName); 
    func(tmp);
    return tmp;
  }

}




int bammer_main(args *pars){
  int nThreads = pars->nThreads;
  func = pars->callback;
  // main_single(argc,argv);
  std::vector<char *> nams;

  //read bamfiles
  if(pars->inputfiles)
    nams = getFilenames(pars->inputfiles,pars->nInd);
  else
    nams.push_back(strdup(pars->inputfile));//if only one file just push bamfile
  //  print(nams,stdout);

  
  bufReader *rd = initializeBufReaders2(nams);
 
  //read regions

  std::vector<char *> regionsRaw;
  if(pars->regionfile)
    regionsRaw = getRegions(pars->regionfile);
  else if(pars->region!=NULL){
    regionsRaw.push_back(strdup(pars->region));//if only one file just push bamfile
  }
  std::vector<regs> regions;
  for(size_t i=0;i<regionsRaw.size();i++){
    regs tmpRegs;
    if(parse_region(regionsRaw[i],*rd[0].hd,tmpRegs.refID,tmpRegs.start,tmpRegs.stop)<0||tmpRegs.stop<tmpRegs.start){
      fprintf(stderr,"[%s] problems with indexing: %s\n",__FUNCTION__,regionsRaw[i]);
      exit(0);
    }else
      regions.push_back(tmpRegs);
  }
  for(size_t i=0;i<nams.size();i++)
    rd[i].regions = regions;


  if(0){
    fprintf(stderr,"-------------\n");
    fprintf(stderr,"regions.size()=%lu\n",regions.size());
    for(uint i=0;i<regions.size();i++)
      fprintf(stderr,"reg[%d]= %d %d %d\n",i,regions[i].refID,regions[i].start,regions[i].stop);
    fprintf(stderr,"-------------\n");
    if(pars->jobtype==1 && pars->inputfiles && (nams.size()!=1)){
      fprintf(stderr,"\n[ERROR]view only implemented for single samples\n");
      pars =0;
    }
  }



  

  //  fprintf(stderr,"Done initing: %lu files, compiled: (%s,%s)\n",nams.size(),__DATE__,__TIME__);
  //uppile single and multiway
  
  //  fprintf(stderr,"jobtype=%d\n",pars->jobtype);

  if(pars->jobtype==2)
    while(motherUppile(nThreads,rd,pars->type,pars->nLines,nams.size(),fucker,pars->show));
  else if(pars->jobtype==1)
    while(motherView(rd,nams.size(),fucker));
  else{
    fprintf(stderr,"nothing to do? what should program do?\n");
  }

  //cleanup stuff
  for(int i=0;i<(int)nams.size();i++){
    free(nams[i]);
    dalloc_bufReader(rd[i]);

  }
  for(size_t i=0;i<regions.size();i++)
    free(regionsRaw[i]);
  delete [] rd;
  free(pars->inputfiles);free(pars->inputfile);free(pars->region);
  delete pars;
  return 0;
}
