/*
  This file implements soapsnp GL estimators.
  
  This is a 2 step precedure
  1) estimate a calibration matrix, based on a mismatch matrix (qs,position,refe,observed)
  2) from number one estimate GL, based on observed data
  
  program will make a directy called angsd_tmpdir/
  it will dump the countsmatrix and the calibration matrix

 */
#include <map>
#include <cmath>
#include <fstream>
#include <libgen.h>//basename
#include <sys/stat.h>//mkdir
#include <sys/types.h>//mkdir
#include "ctype.h"
#include "mUpPile.h"
#include "soap_likes.h"

extern int fexists(const char* str);
//calc_offset
int co(int a, int b, int c, int d){
  return (a<<12 | b<<4 | c<<2|d );
}



#define LENSS 100000

int conv[4] = {0,1,3,2};

extern int refToInt[256];

typedef struct{
  char qs;
  char pos;
  int isUpper;
}tmpStruct;

//traverse qs(hight->low),posi(low->high),BIGLETTER->smallletters

struct cmp_tmpStruct {
  bool operator()(const tmpStruct& first,const  tmpStruct& second) {
    if(first.qs!=second.qs)
      return first.qs>second.qs;
    else if (first.pos!=second.pos)
      return first.pos<second.pos;
    else
      return first.isUpper >second.isUpper;
  }
};



typedef std::multimap<tmpStruct,int ,cmp_tmpStruct> soapMap;

int mySum(int ary[4]){
  int tsum =0;
  for(int i=0;i<4;i++)
    tsum += ary[i];
  return tsum;
}

//FILE *dumpMe = fopen("dumpMe.txt","w");

//this function does the GL estimation, must supply a calibration matrix
int do_glf(chunkyT *chk,double *p_matrix,int which_sample,int read_len,double **lk,int min_base_q,int min_map_q) {
  //  fprintf(stderr,"[%s]\n",__FUNCTION__);


  double pcr_dependency = log10(0.5);
  double global_dependency = log10(0.9);

  for(int s=0;s<chk->nSites;s++) {
    if(which_sample==0){
      //      fprintf(stderr,"doubleling=%d\n",s);
      lk[s] = new double[10*chk->nSamples];
      for(int i=0;i<10*chk->nSamples;i++)
	lk[s][i] = -0.0;
    }
    int global_dep_count[4] = {-1,-1,-1,-1};
    int pcr_dep_count[4][2*read_len];
    for(int ii=0;ii<4;ii++) 
      memset(pcr_dep_count[ii],0,sizeof(int)*2*read_len);
    tNode &nd = chk->nd[s][which_sample];
    double type_likely[4][4] = {{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};

    soapMap aMap;

    //roll values into the map
    for(int j=0;j<nd.l;j++) {
      //soapsnp only allows 255s
      if(aMap.size()>=0xFF)
	break;
      tmpStruct t;
      if(nd.qs[j]<0){
	fprintf(stderr,"Meaningless low quality\n");
	continue;
      }
      if(nd.qs[j]<min_base_q||nd.mapQ[j]<min_map_q){
	continue;
      }


      t.qs=nd.qs[j];
      if(refToInt[nd.seq[j]]==4)//catch the annoying n/N
	continue;
      if(1&&isupper(nd.seq[j]))
	t.pos= nd.posi[j];
      else
	t.pos= nd.isop[j];
      t.isUpper = isupper(nd.seq[j]);
      aMap.insert(std::pair<tmpStruct,int>(t,j));
    }


    //    for(int j=0;j<nd.l;j++) {
    for(soapMap::iterator it=aMap.begin();it!=aMap.end();++it) {
      int j=it->second;
      int workId = isupper(nd.seq[j])?nd.posi[j]:read_len+nd.isop[j];
      int alleleID = conv[refToInt[nd.seq[j]]];//{0,1,2,3}
      
      if(pcr_dep_count[alleleID][workId]==0)
	global_dep_count[alleleID] += 1;

      pcr_dep_count[alleleID][workId]++;
      if(0){
	if(0){
	  fprintf(stderr,"\nqs=%d\toffsetted=%d workId=%d alleleId=%d\n",nd.qs[j],nd.qs[j],workId,alleleID);
	  fprintf(stderr,"[tsk] q_score=%d\tlog10(qscore)=%f\n",nd.qs[j],log10(nd.qs[j]));
	  fprintf(stderr,"[tsk] next=%d\n",(pcr_dep_count[alleleID][workId]-1));
	  fprintf(stderr,"[tsk] next2=%f\tnext3=%f\n",pcr_dependency,global_dep_count[alleleID]*global_dependency);
	  fprintf(stderr,"[tsk] all=%f\n", pow(10, (log10(nd.qs[j]) +(pcr_dep_count[alleleID][workId]-1)*pcr_dependency +global_dep_count[alleleID]*global_dependency))+0.5);
	}
	fprintf(stderr,"\nqs=%d\tpcr=%d\n",nd.qs[j],(pcr_dep_count[alleleID][workId]-1));
	fprintf(stderr,"pcrdep=%f\tglob_dep=%f\n",pcr_dependency,global_dependency);
	fprintf(stderr,"global_dep_count[alleleID]=%d\n",global_dep_count[alleleID]);

	fprintf(stderr,"led2=%f\tled3=%f\n",(pcr_dep_count[alleleID][workId]-1)*pcr_dependency, global_dep_count[alleleID]*global_dependency);
      }
      double led1= (pcr_dep_count[alleleID][workId]-1)*pcr_dependency;
      double led2 =  global_dep_count[alleleID]*global_dependency;
      double led3 =nd.qs[j]*pow(10,led1+led2)+0.5;//+0.5000001;//this small eps addition is to make it work like soapsnp.

      if(0&&nd.refPos==9428736){
	/*
	fwrite(&led1,1,sizeof(double),dumpMe);
	fwrite(&led2,1,sizeof(double),dumpMe);
	fwrite(&led3,1,sizeof(double),dumpMe);
	//	fclose(dumpMe);
	*/
	fprintf(stderr,"ledONE=%f\tledTWO=%f\n",led1,led2);
	fprintf(stderr,"led3=%f\n",led3);
	
      }
      int q_adjusted = int(led3);
      
      if(q_adjusted < 1)
	q_adjusted = 1;
      //      fprintf(stderr,"qadj=%d\n",q_adjusted);
      int coord;
      if(isupper(nd.seq[j]))
	coord = nd.posi[j];
      else
	coord = nd.isop[j];
      //      fprintf(stderr,"coord=%d\n",coord);
      for(int allele1 = 0;allele1 != 4;allele1++ ) {
	for(int allele2 = allele1; allele2 != 4; allele2++) {
	  type_likely[allele1][allele2] += log10(0.5*p_matrix[co(q_adjusted,coord,allele1,alleleID)] +0.5*p_matrix[co(q_adjusted,coord,allele2,alleleID)]);
	  
	}
      }
    }
    if(mySum(global_dep_count)==-4)
      continue;
    if(0){//dump results
      FILE *fp = stdout;

      fprintf(fp,"pos=%d\tl=%d\t",nd.refPos,nd.l);
      //    fprintf(fp,"pos=%d\t",nd.refPos);
      fprintf(fp,"%f\t",type_likely[0][0]);//AA
      fprintf(fp,"%f\t",type_likely[1][1]);//CC
      fprintf(fp,"%f\t",type_likely[3][3]);//GG
      fprintf(fp,"%f\t",type_likely[2][2]);//TT
      fprintf(fp,"%f\t",type_likely[0][1]);//AC
      fprintf(fp,"%f\t",type_likely[0][3]);//AG
      fprintf(fp,"%f\t",type_likely[0][2]);//AT
      fprintf(fp,"%f\t",type_likely[1][3]);//CG
      fprintf(fp,"%f\t",type_likely[1][2]);//CT
      fprintf(fp,"%f\n",type_likely[2][3]);//GT
    }
    //plugin likelihoods according, alloc for all samples if working with firstsample

    //soap snp order printf("#AA,CC,GG,TT,AC,AG,AT,CG,CT,GT\n")
    double *tmpLk = lk[s]+10*which_sample;
    tmpLk[0] = type_likely[0][0];//AA
    tmpLk[1] = type_likely[0][1];//AC
    tmpLk[2] = type_likely[0][3];//AG
    tmpLk[3] = type_likely[0][2];//AT
    tmpLk[4] = type_likely[1][1];//CC
    tmpLk[5] = type_likely[1][3];//CG
    tmpLk[6] = type_likely[1][2];//CT
    tmpLk[7] = type_likely[3][3];//GG
    tmpLk[8] = type_likely[2][3];//GT
    tmpLk[9] = type_likely[2][2];//TT

    for(int i=0;i<10;i++)//swap to normal log
      tmpLk[i] *= log(10.0);

    double mmax = tmpLk[0];//rescale to most likely
    for(int i=1;i<10;i++)
      if(tmpLk[i]>mmax)
	mmax = tmpLk[i];
    for(int i=0;i<10;i++)
      tmpLk[i] -= mmax;
  }
  return 1;
}

void count_qual(size_t *count_matrix, int q_min,int q_max,int read_length,const char*fname) {
  double *p_matrix = new double [256*256*4*4];
  //  size_t coord;
  size_t o_base/*o_based base*/;
  size_t t_base/*theorecical(supposed) base*/;
  size_t sum[4];
  size_t  same_qual_count_by_type[4][4];// = {{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
  size_t  same_qual_count_by_t_base[4];// = {0,0,0,0};
  size_t  same_qual_count_total;
  size_t  same_qual_count_mismatch;
  
  const size_t sta_pow=10; // minimum number to say statistically powerful
  fprintf(stderr,"qchar_min =%d \t q_charmax=%d\n",q_min,q_max);
  for(int q_char=q_min; q_char<=q_max ;q_char++)  {
    memset(same_qual_count_by_t_base,0,sizeof(size_t)*4);
    for(int i=0;i<4;i++)
      memset(same_qual_count_by_type[i],0,sizeof(size_t)*4);

    
    same_qual_count_total = 0;
    same_qual_count_mismatch = 0;
    for(int coord=0; coord != read_length ; coord++) {
      for(int t1=0;t1<4;t1++)
        for(int t2=0;t2<4;t2++){
          // If the sample is small, then we will not consider the effect of read cycle.
	  int funkyOffset = co(q_char,coord,t1,t2);
          same_qual_count_by_type[t1][t2] += count_matrix[funkyOffset];
          same_qual_count_by_t_base[t1] += count_matrix[funkyOffset];
          same_qual_count_total += count_matrix[funkyOffset];
          if(t1!= t2) 
	    // Mismatches
	    same_qual_count_mismatch += count_matrix[funkyOffset ];
        
        }
    }


    for(int coord=0; coord != read_length ; coord++) {
      memset(sum, (size_t)0, sizeof(size_t)*4);
      // Count of all ref base at certain coord and quality
      for(int t1=0;t1<4;t1++)
        for(int t2=0;t2<4;t2++)
          sum[t1] += count_matrix[co(q_char,coord,t1,t2)]; // (type>>2)&3: the ref base

      for(t_base=0; t_base!=4; t_base++) {
        for(o_base=0; o_base!=4; o_base++) {
	  int fo = co( q_char,coord,t_base, o_base);
	  if (count_matrix[fo] > sta_pow) {
	    // Statistically powerful
            p_matrix[fo] = ((double)count_matrix[fo]) /((double) sum[t_base]);
          }
          else if (same_qual_count_by_type[t_base][o_base] > sta_pow) {
	    // Smaller sample, given up effect from read cycle
            p_matrix [fo] =  ((double)same_qual_count_by_type[t_base][o_base]) /((double) same_qual_count_by_t_base[t_base]);
          }
          else if (same_qual_count_total > 0){
	    // Too small sample, given up effect of mismatch types
            if (o_base == t_base) {
	      p_matrix [fo] = ((double)(same_qual_count_total-same_qual_count_mismatch))/((double)same_qual_count_total);
            }
            else {
	      p_matrix [fo] = ((double)same_qual_count_mismatch)/same_qual_count_total;
            }
          }
          else {
            ;
          }

          // For these cases like:
          // Ref: G o_base: G x10 Ax5. When calculate the probability of this allele to be A,
          // If there's no A in reference gives observation of G, then the probability will be zero,
          // And therefore exclude the possibility of this pos to have an A
          // These cases should be avoid when the dataset is large enough
          // If no base with certain quality is o_based, it also doesn't matter

          if( (p_matrix [fo]==0) || (p_matrix [fo] ==1)) {
            if (o_base == t_base) {
              p_matrix [fo] = (1-pow(10, -((q_char-q_min)/10.0)));
	      if(p_matrix [fo]<0.25) {
                p_matrix [fo] = 0.25;
              }
            }
            else {
              p_matrix [fo] = (pow(10, -((q_char-q_min)/10.0))/3);
	      if(p_matrix [fo]>0.25) {
                p_matrix [fo] = 0.25;
              }
            }
          }
        }
      }

    }
  }
  if(1) {
    std::fstream fp;
    fprintf(stderr,"[%s] dumping file:%s\n",__FUNCTION__,fname);
    fp.open(fname,std::fstream::out);
    for(int qc = q_min;qc<=q_max;qc++) {
      for(int i=0;i<read_length;i++) {
	fp<< qc-q_min << '\t' << i;
	for(int a1=0;a1<4;a1++)
	  for(int a2=0;a2<4;a2++)
	    fp << '\t' << p_matrix[co(qc,i,conv[a1],conv[a2])];
      fp << std::endl;
      }
    }
    fp.close();
  }
  delete [] p_matrix;
}


int actuallyrun =0;
void gen_counts(chunkyT *chk,size_t *count_matrix,int whichSample,char *refs) {
  //qs,seqpos,ref,nuc
  int printOrder[4] = {0,1,3,2};


  actuallyrun += chk->nSites;

  for(int s=0;s<chk->nSites;s++) {
    //    fprintf(stderr,"%c\n",refs[s]);
    if(refs[s]==4)
      continue;
    
    for(int l=0;l<chk->nd[s][whichSample].l;l++){
      char nuc = chk->nd[s][whichSample].seq[l];
      if(nuc =='n' || nuc=='N')
        continue;

      /*
        increment:
        [qs][position in read][reference][nucleotide]
      */
      int funkyOffset =0;
      if(isupper(nuc))//qs not +33 anymore
	funkyOffset = co(chk->nd[s][whichSample].qs[l], chk->nd[s][whichSample].posi[l],refs[s],refToInt[chk->nd[s][whichSample].seq[l]]);
      else
	funkyOffset = co(chk->nd[s][whichSample].qs[l], chk->nd[s][whichSample].isop[l],refs[s],refToInt[chk->nd[s][whichSample].seq[l]]);
      
      count_matrix[funkyOffset]++;//increment the correct offset.
	
    }
  }
}






void dump_count_mat(const char *fname,size_t *count_mat,int start,int stop,int rlen){
  fprintf(stderr,"[%s] dumping file:%s\n",__FUNCTION__,fname);
  int printOrder[4] = {0,1,3,2};
    FILE *fpp = fopen(fname,"w");
    for(int i=start;i<=stop;i++) {
      for(int n=0;n<rlen;n++){
	fprintf(fpp,"%d\t%d\t",i, n);
	for(int a1=0;a1<4;a1++)
	  for(int a2=0;a2<4;a2++)
	    fprintf(fpp,"%lu\t",count_mat[co(i,n,printOrder[a1],printOrder[a2])]);//+33 to conform with soapsnp version, just debug..
	fprintf(fpp,"\n");
      }
    }
    fclose(fpp);
    
}


void soap_likes::run(chunkyT *chk,double **lk,char *refs,int min_base_q,int min_map_q) {
  //  fprintf(stderr,"calliing runs\n");
  if(chk==NULL) {
    fprintf(stderr,"[%s] received null chunk will cleanup: qcharmin=%d qcharmax=%d\n",__FUNCTION__,qchar_min,qchar_max);
    //exit(0);
    
    return;
  }

  if(gen_p_mat==0)
    for(int i=0;i<chk->nSamples;i++)
      do_glf(chk,p_matrix[i],i,read_len,lk, min_base_q,min_map_q);
  else{
    //    fprintf(stderr," incremingint count matrix\n");
    if(refs==NULL){
      fprintf(stderr,"Must supply reference for SOAPsnp calibration\n");
      exit(0);
    }
    for(int i=0;i<chk->nSamples;i++)
      gen_counts(chk,count_mat[i],i,refs);
  }
}


void soap_likes::setCaliNames(std::vector<char*> &bFnames){
  fprintf(stderr,"setcalinames\n");
  for(uint i=0;i<bFnames.size();i++){
    char *ret1 = new char[128];
    char *ret2 = new char[128];
    snprintf(ret1,128,"%s/%s.qual%d",tmpdir,basename(bFnames[i]),i);
    snprintf(ret2,128,"%s/%s.counts%d",tmpdir,basename(bFnames[i]),i);
    if(strlen(ret1)>100||strlen(ret1)>100){
      fprintf(stderr,"Might be problems with to long filenames\n");
      fprintf(stderr,"Please check/modify this function: %s in file:%s\n",__FUNCTION__,__FILE__);
    }
    p_mat_names.push_back(ret1);
    count_mat_names.push_back(ret2);
  }
  
}

int soap_likes::p_mat_exists(){
  
  for(size_t i=0;i<p_mat_names.size();i++){
    fprintf(stderr,"checking [%s]\n",p_mat_names[i]);
    if(fexists(p_mat_names[i])==0)
      return 0;
  }
  return 1;
}

//simple filereader of a precalculated calibration matrix
double *get_p_matrix(const char*fname,size_t read_len,size_t qchar_max){
  fprintf(stderr,"[%s] reading file: %s\n",__FUNCTION__,fname);
  //  double *p_matrix = new double [read_len*qchar_max*4*4];
  double *p_matrix = new double [256*256*4*4];
  for(size_t i=0;i<read_len*qchar_max*4*4;i++)
    p_matrix[i] = 0.0;

  //now plug in values
  FILE *fp = fopen(fname,"r");
  char buf[LENSS];

  for(size_t i=0;i<qchar_max;i++){//size_t to avoid typecasting when bitshifting
    for(size_t j=0;j<read_len;j++){
      if(!fgets(buf,LENSS,fp))
	fprintf(stderr,"Reading something that is NULL:\n");
      strtok(buf,"\t\n ");
      strtok(NULL,"\t\n ");
      for(int al2=0;al2<16;al2++){
	p_matrix[(i<<12) | (j<<4) |al2   ] = atof(strtok(NULL,"\t \n"));
      }
      //	p_matrix[i][j][al2/4][al2 %4] = atof(strtok(NULL,"\t \n"));
    }
  }
  fclose(fp);
  return p_matrix;
}



//int soap_likes::init(int nSamples_a){
int soap_likes::init(std::vector<char *> &bFnames,int qmin,int qmax,int rlen){
  fprintf(stderr,"qmin=%d qmax=%d\n",qmin,qmax);
  qchar_min = qmin;
  qchar_max =qmax; 
  read_len = rlen;

  p_matrix = NULL;
  count_mat = NULL;
  tmpdir = "angsd_tmpdir";
  mkdir(tmpdir,0777);
  

  nSamples = bFnames.size();


  // setCaliNames(mUpPile_rd,nSamples);
  fprintf(stderr,"[%s.%s()] initing with: qmin=%d,qmax=%d,rlen=%d\n",__FILE__,__FUNCTION__,qchar_min,qchar_max,read_len);
  setCaliNames(bFnames);
  if(p_mat_exists()==0){
    fprintf(stderr,"Calibration matrix doesn't exist now allocating important stuff\n");
    gen_p_mat =1;
    count_mat = new size_t*[nSamples];
    for(int i=0;i<nSamples;i++){
      count_mat[i] = new size_t[256*256*4*4];
      memset(count_mat[i],0,sizeof(size_t)*256*256*4*4);
    }
    
  }else{
    p_matrix = new double*[nSamples];
    for(int i=0;i<nSamples;i++)
      p_matrix[i] = get_p_matrix(p_mat_names[i],read_len,qchar_max); 
    gen_p_mat =0;
  }
  return !gen_p_mat;
}

soap_likes::~soap_likes(){
  //  fprintf(stderr,"soaplikes destructor\n");
  
  if(gen_p_mat)
    for(int i=0;i<nSamples;i++){//dumpcount and qual
      dump_count_mat(count_mat_names[i],count_mat[i],qchar_min,qchar_max,read_len);
      count_qual(count_mat[i],qchar_min,qchar_max,read_len,p_mat_names[i]);
    }
  
}
